#!/usr/bin/env python
"""
Copyright 2014-2020 by Taxamo

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""
class Input_transaction:
    """NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually."""


    def __init__(self):
        self.swaggerTypes = {
            'payment_address': 'payment_address',
            'order_date_type': 'str',
            'buyer_credit_card_prefix': 'str',
            'custom_data': 'str',
            'buyer_name': 'str',
            'invoice_date': 'str',
            'currency_code': 'str',
            'sub_account_id': 'str',
            'supply_date': 'str',
            'control_flags': 'list[control_flags]',
            'invoice_address': 'invoice_address',
            'verification_token': 'str',
            'note': 'str',
            'tax_data': 'tax_data_schema',
            'transaction_lines': 'list[input_transaction_line]',
            'buyer_tax_number': 'str',
            'additional_interactions': 'list[additional_interactions]',
            'status': 'str',
            'custom_fields': 'list[custom_fields]',
            'force_country_code': 'str',
            'invoice_number': 'str',
            'order_date': 'str',
            'external_unique_id': 'str',
            'customer_id': 'str',
            'comments': 'str',
            'buyer_ip': 'str',
            'buyer_email': 'str',
            'original_transaction_key': 'str',
            'billing_country_code': 'str',
            'custom_id': 'str',
            'additional_currencies': 'additional_currencies',
            'ship_to_address': 'ship_to_address',
            'invoice_place': 'str',
            'evidence': 'evidence',
            'description': 'str',
            'tax_deducted': 'bool',
            'tax_country_code': 'str'

        }


        #Payment address.
        self.payment_address = None # payment_address
        #'timestamp' means that an order date was captured with a full timestamp and can be applied to an FX source which distinguishes time of the day. Empty value or 'day' means that only day information is present.
        self.order_date_type = None # str
        #First 6 digits of buyer's credit card prefix.
        self.buyer_credit_card_prefix = None # str
        #Custom data related to transaction.
        self.custom_data = None # str
        #Buyer's name - first name and last name or company name.
        self.buyer_name = None # str
        #Invoice date of issue.
        self.invoice_date = None # str
        #Currency code for transaction - e.g. EUR.
        self.currency_code = None # str
        #Sub account identifier.
        self.sub_account_id = None # str
        #Supply date in yyyy-MM-dd format.
        self.supply_date = None # str
        #Control flags, stored as key-value string pairs. Possible flags (keys): &quot;b2b-number-service-timeoutms&quot;, &quot;b2b-number-service-expiry-days&quot;, &quot;b2b-number-service-on-error&quot; (value &quot;accept&quot;). Region code can be appended to all of the keys, e.g. &quot;b2b-number-service-timeoutms-EU&quot;. 
        self.control_flags = None # list[control_flags]
        #Invoice address.
        self.invoice_address = None # invoice_address
        #Verification token
        self.verification_token = None # str
        #Additional note related to transaction state - for example if the transaction was created in a 'catch-all' mode or the VAT number re-check for subscriptions has failed.
        self.note = None # str
        #Tax additional information - e.g. US sales tax exemption certificate data.
        self.tax_data = None # tax_data_schema
        #Transaction lines.
        self.transaction_lines = None # list[input_transaction_line]
        # Buyer's tax number - EU VAT number for example. If using EU VAT number, it is possible to provide country code in it (e.g. IE1234567X) or simply use billing_country_code field for that. In the first case, if billing_country_code value was provided, it will be overwritten with country code value extracted from VAT number - but only if the VAT has been verified properly.
        self.buyer_tax_number = None # str
        #Information about additional interactions necessary/available.
        self.additional_interactions = None # list[additional_interactions]
        #Transaction status: 'N' - new, 'C' - confirmed. Can use 'C' in store-transaction! with private-token to create confirmed transaction, otherwise 'N' is default status. Not applicable for update-transaction!.
        self.status = None # str
        #Custom fields, stored as key-value pairs. This property is not processed and used mostly with Taxamo-built helpers.
        self.custom_fields = None # list[custom_fields]
        #Two-letter ISO country code, e.g. FR. Use it to force country code for tax calculation.
        self.force_country_code = None # str
        #Invoice number.
        self.invoice_number = None # str
        #Order date in yyyy-MM-dd or yyyy-MM-dd HH:mm:ss or yyyy-MM-dd'T'HH:mm:ss'Z' format, in merchant's timezone. If provided by the API caller, no timezone conversion is performed. Default value is current date and time in merchant's timezone. When using public token, the default value is used. When time is provided, it is assumed that the date has full resolution, which affects some regions FX rate calculation - Serbia for example.
        self.order_date = None # str
        #External unique id. It is advised to use secure and random identifiers in this field.
        self.external_unique_id = None # str
        #Free-form field for storing customer id.
        self.customer_id = None # str
        #Additional information about the transaction - for example if the evidence has been amended.
        self.comments = None # str
        #IP address of the buyer in dotted decimal (IPv4) or text format (IPv6).
        self.buyer_ip = None # str
        #Buyer's declared email address.
        self.buyer_email = None # str
        #Use data and evidence from original transaction. Tax will be re-calculated, but evidence won't be re-checked. This parameter is taken into account only when 'manual' flag is raised.
        self.original_transaction_key = None # str
        #Billing two letter ISO country code.
        self.billing_country_code = None # str
        #Custom identifier provided upon transaction creation.
        self.custom_id = None # str
        #Additional currency information - can be used to receive additional information about invoice in another currency.
        self.additional_currencies = None # additional_currencies
        #Ship to address
        self.ship_to_address = None # ship_to_address
        #Invoice place of issue.
        self.invoice_place = None # str
        #Tax country of residence evidence.
        self.evidence = None # evidence
        #Transaction description.
        self.description = None # str
        #True if the transaction is deducted from tax and no tax is applied (it is untaxed). Either set automatically when VAT number validates with VIES correctly, but can also be provided in manual mode.
        self.tax_deducted = None # bool
        #Two-letter ISO country code, e.g. FR. This code applies to detected/set country for transaction, but can be set using manual mode.
        self.tax_country_code = None # str
        
